#ifndef __G_ETREE_MODEL_HEADER_INCLUDED__
#define __G_ETREE_MODEL_HEADER_INCLUDED__

#define ETREE_MODEL_TYPE (etree_model_get_type())
#define ETREE_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), ETREE_MODEL_TYPE, EtreeModel))
#define IS_ETREE_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), ETREE_MODEL_TYPE))

typedef struct _EtreeModel EtreeModel;
typedef struct _EtreeModelClass EtreeModelClass;

#define ETREE_ICON	0 /* pixbuf */
#define ETREE_PRIO	1 /* string */
#define ETREE_SRC	2 /* string */
#define ETREE_DST	3 /* string */
#define ETREE_GEN	4 /* string */
#define ETREE_MSG	5 /* string */
#define ETREE_TIME	6 /* string */
#define ETREE_MAX	7

GType etree_model_get_type(void);

EtreeModel *etree_model_new(void);
void etree_model_set_appbar(EtreeModel *e, GnomeAppBar *a);
void etree_model_close(EtreeModel *e);
int etree_model_open(EtreeModel *e, int fd);
int etree_model_get(EtreeModel *e, GtkTreeIter *iter,
			proc_elogfn cb, gpointer user_data);

struct _EtreeModel {
	GObject parent;

	/*< private >*/
	gint stamp;
	size_t num_pkts;
	size_t *ofs;
	void *efile;
	GnomeAppBar *appbar;
};

struct _EtreeModelClass {
	GObjectClass parent_class;
};

static size_t etree_model_num_pkts(EtreeModel *e)
{
	g_return_if_fail(IS_ETREE_MODEL(e));
	return e->num_pkts;
}

#endif /* __G_ETREE_MODEL_HEADER_INCLUDED__ */
