#ifndef __PKT_HTTP_HEADER_INCLUDED__
#define __PKT_HTTP_HEADER_INCLUDED__

#define HTTP_REQUEST 0
#define HTTP_RESPONSE 1

#define HTTPS_HEADER	0
#define HTTPS_CONTENT	1
#define HTTPS_CHUNKED	2
#define HTTPS_CLOSING	3

struct http_request {
	int type;
	struct fvec uri;
	struct fvec method;
};

struct http_response {
	int type;
	int code;
};

struct http_fside {
	u_int16_t state;
	u_int16_t pstate;
	size_t len;
};

struct http_flow {
	struct http_fside client;
	struct http_fside server;
};

struct http_serial_req {
	u_int32_t type;
	u_int32_t uri;
	u_int32_t uri_len;
	u_int32_t method;
	u_int32_t method_len;
};

struct http_serial_resp {
	u_int32_t type;
	int32_t code;
};

#endif /* __PKT_HTTP_HEADER_INCLUDED__ */
