#include "match_tcp.h"
PLUGIN_STD_DEFS();

struct matcher tcp_matchers[]={
	matcher_init("flow", 9, flow_validate, MCMP_LR, MATCHER_FREE),
	matcher_init("stateless", 9,stateless_validate, MCMP_LR, MATCHER_FREE),
	matcher_init("tcp_sport", 13, tcp_src_validate, MCMP_SR, MATCHER_FREE),
	matcher_init("tcp_dport", 14, tcp_dst_validate, MCMP_SR, MATCHER_FREE),
	matcher_init("seq", MCOST_TRANS+4, seq_validate, MCMP_LR, MATCHER_FREE),
	matcher_init("ack", MCOST_TRANS+6, ack_validate, MCMP_LR, MATCHER_FREE),
	matcher_init("flags", MCOST_TRANS+13, flags_validate, flags_compare, MATCHER_FREE),
	matcher_null()
};

int PLUGIN_MATCHER (struct matcher_api *m)
{
	object_check(m);

	template_shortrange=m->template_shortrange;
	template_longrange=m->template_longrange;

	if ( !m->matcher_add(tcp_matchers) )
		return PLUGIN_ERR_FAIL;

	return PLUGIN_ERR_OK;
}

int PLUGIN_INIT (struct plugin_in *in, struct plugin_out *out)
{
	plugin_check(in, out);

	PLUGIN_ID("match.tcp", "TCP matching routines");
	PLUGIN_VERSION(2, 0);
	PLUGIN_AUTHOR("Gianni Tedesco", "gianni@scaramanga.co.uk");
	PLUGIN_LICENSE("GPL");

	return PLUGIN_ERR_OK;
}

int PLUGIN_UNLOAD (int code) {
	return PLUGIN_ERR_OK;
}
