#ifndef __MATCH_TCP_HEADER_INCLUDED__
#define __MATCH_TCP_HEADER_INCLUDED__

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include <firestorm.h>
#include <packet.h>
#include <alert.h>
#include <signature.h>
#include <matcher.h>
#include <plugin.h>

/* generic stuff */
proc_match_match tcp_src_validate(char *args, void **priv,
	struct criteria *m, u_int32_t *);
proc_match_match tcp_dst_validate(char *args, void **priv,
	struct criteria *m, u_int32_t *);
proc_template template_longrange;
proc_template template_shortrange;

/* port stuff */
proc_match_match flow_validate(char *, void **, struct criteria *, u_int32_t *);
proc_match_match stateless_validate(char *, void **, struct criteria *, u_int32_t *);

/* seq stuff */
proc_match_match seq_validate(char *, void **, struct criteria *, u_int32_t *);

/* ack stuff */
proc_match_match ack_validate(char *, void **, struct criteria *, u_int32_t *);

/* flags stuff */
proc_match_match flags_validate(char *, void **, struct criteria *, u_int32_t *);
int flags_compare(void *, void *);

#endif /* __MATCH_TCP_HEADER_INCLUDED__ */
