/*
* This file is part of Firestorm NIDS
* Copyright (c) 2002 Gianni Tedesco
* This program is released under the terms of the GNU GPL version 2
*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <firestorm.h>
#include <packet.h>
#include <alert.h>

/* List of all registered alert generators */
struct generator *generators=NULL;
unsigned int num_generators=0;

/* Register an alert generator */
int generator_add(struct generator *g)
{
	if ( !g || g->next || !g->name ) {
		mesg(M_WARN,"alert: generator failed to add. "
			"that could really fuck things up");
		return 0;
	}

	g->next=generators;
	generators=g;
	num_generators++;
	return 1;
}

/* Find a registered alert generator */
struct generator *generator_find(char *n)
{
	struct generator *g;
	for(g=generators; g; g=g->next) {
		if ( !strcmp(g->name, n) ) return g;
	}
	return NULL;
}
